diff -u asterisk-1.4.13/main/channel.c{~,}
--- asterisk-1.4.13/main/channel.c~	2007-10-09 15:55:06.000000000 -0600
+++ asterisk-1.4.13/main/channel.c	2007-11-14 17:01:44.000000000 -0600
@@ -1056,7 +1056,7 @@
 				 */
 			}
 			if (name) { /* want match by name */
-				if ((!namelen && strcasecmp(c->name, name)) ||
+				if ((!namelen && strcasecmp(c->name, name) && strcmp(c->uniqueid, name)) ||
 				    (namelen && strncasecmp(c->name, name, namelen)))
 					continue;	/* name match failed */
 			} else if (exten) {
@@ -3643,6 +3643,15 @@
 	/* Mangle the name of the clone channel */
 	ast_string_field_set(clone, name, masqn);
 
+	if (original->tech == &null_tech) {
+		/* Swap the clone and original's uniqueids, since the
+		   clone doesn't really exist yet. */
+		char clone_uid[100];
+		ast_copy_string(clone_uid, clone->uniqueid, sizeof(clone_uid));
+		ast_string_field_set(clone, uniqueid, original->uniqueid);
+		ast_string_field_set(original, uniqueid, clone_uid);
+	}
+	
 	/* Notify any managers of the change, first the masq then the other */
 	manager_event(EVENT_FLAG_CALL, "Rename", "Oldname: %s\r\nNewname: %s\r\nUniqueid: %s\r\n", newn, masqn, clone->uniqueid);
 	manager_event(EVENT_FLAG_CALL, "Rename", "Oldname: %s\r\nNewname: %s\r\nUniqueid: %s\r\n", orig, newn, original->uniqueid);
--- asterisk-1.4.13/main/cli.c~	2007-10-12 23:48:10.000000000 -0600
+++ asterisk-1.4.13/main/cli.c	2007-11-28 15:57:14.000000000 -0600
@@ -640,7 +640,7 @@
 			durbuf[0] = '\0';
 		}
 		if (concise) {
-			ast_cli(fd, CONCISE_FORMAT_STRING, c->name, c->context, c->exten, c->priority, ast_state2str(c->_state),
+			ast_cli(fd, CONCISE_FORMAT_STRING, c->uniqueid, c->context, c->exten, c->priority, ast_state2str(c->_state),
 			        c->appl ? c->appl : "(None)",
 				S_OR(c->data, ""),	/* XXX different from verbose ? */
 			        S_OR(c->cid.cid_num, ""),
@@ -720,7 +720,7 @@
 			durbuf[0] = '\0';
 		}
 		if (concise) {
-			ast_cli(fd, CONCISE_FORMAT_STRING, c->name, c->context, c->exten, c->priority, ast_state2str(c->_state),
+			ast_cli(fd, CONCISE_FORMAT_STRING, c->uniqueid, c->context, c->exten, c->priority, ast_state2str(c->_state),
 			        c->appl ? c->appl : "(None)",
 				S_OR(c->data, ""),	/* XXX different from verbose ? */
 			        S_OR(c->cid.cid_num, ""),
